<template>
  <FloatingCreateButton
    :shown="isShown"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-plus"
        headline="Создание объекта"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Название объекта">
          <v-text-field
            v-model="newProperty.name"
            :rules="[validateName]"
            :maxlength="MAX_PROPERTY_NAME_LENGTH"
            placeholder="Название"
          />
        </FormRow>

        <FormRow label="Количество мест">
          <NumberInput
            v-model="newProperty.capacity"
            mode="integer"
            :min="MIN_PROPERTY_CAPACITY"
            :max="SMALL_INT_SIZE"
            :step="1"
          />
        </FormRow>

        <FormRow label="Назначенный цвет">
          <ColorPicker v-model="newProperty.color" />
        </FormRow>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, reactive, ref, watch } from 'vue';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import FloatingCreateButton from '@/components/layout/FloatingCreateButton.vue';

import ColorPicker from '@/components/content/ColorPicker.vue';
import NumberInput from '@/components/content/NumberInput.vue';
import Feedback from '@/components/content/Feedback.vue';

import { createStringValidator } from '@/validators';
import { usePropertiesStore } from '@/stores';

import {
  MIN_PROPERTY_NAME_LENGTH,
  MAX_PROPERTY_NAME_LENGTH,
  MIN_PROPERTY_CAPACITY,
  DEFAULT_CAPACITY_VALUE,
  SMALL_INT_SIZE,
} from '@/declarations';

const propertiesStore = usePropertiesStore();
const validateName = createStringValidator({
  required: true,
  length: { min: MIN_PROPERTY_NAME_LENGTH, max: MAX_PROPERTY_NAME_LENGTH },
});

const isLoading = ref(false);
const isShown = ref(false);
const feedback = ref('');

const newProperty = reactive({
  name: '',
  capacity: DEFAULT_CAPACITY_VALUE,
  color: '',
});

const isDataFilled = computed(() => {
  const isNameEntered = validateName(newProperty.name) === true;
  const isCapacityEntered = newProperty.capacity >= MIN_PROPERTY_CAPACITY;
  const isColorChosen = Boolean(newProperty.color);

  return isNameEntered && isCapacityEntered && isColorChosen;
});

const onCreateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await propertiesStore.createProperty({
    name: newProperty.name.trim(),
    capacity: newProperty.capacity,
    color: newProperty.color,
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  newProperty.name = '';
  newProperty.capacity = DEFAULT_CAPACITY_VALUE;
  newProperty.color = '';

  feedback.value = '';
});
</script>